/* build_version.c */
/* easy.c */
void easy_die(char *message, int ret);
double easy_time(void);
void easy_sleep(double seconds);
int csv_parse(char *in, unsigned char def, char *argv[], int max);
char *_strncpy(char *dest, const char *src, size_t n);
void hhmmss(char *output, time_t timer);
void the_date(char *the_date, char *the_time, time_t t);
void time_ago(time_t then, time_t now, char *output);
char *str_invalid(char *str, char *invalid);
void iso_time_str(time_t stamp, char *str);
int copy_file(char *fsrc, char *fdest);
void alloc_exit(void);
void _malloc_init(void);
void *easy_realloc(const char *file, const int line, const void *ma, const size_t ms);
void *easy_malloc(const char *file, const int line, const size_t ms);
void _free(void *ms);
void malloc_canary_test(void);
int _malloc_memory_increase(void);
int strlen_no_color(char *str);
void strim(char *type, char *str);
char *_strsplitcpy(char *in, unsigned char def, char *out, int outlength);
char *psnprintf(char *out, int length, char *str, ...);
void easy_mkdir(char *path);
void str_color_strip(char *str);
float easy_distance_from(struct float_xyzuv from, struct float_xyzuv to);
int csv_parse_alloc(char *in, unsigned char def, char *argv[], int max);
void csv_unparse(char *argv[], int max, unsigned char def, char *buffer);
char *easy_get_exec_path(char *path, size_t dest_len, char *argv0);
/* map_server.c */
void backtrace_sigsegv_handler(int number);
void the_signal_handler(int signum);
void server_shutdown(void);
int main(int argc, char **argv);
void map_server_initialize(int reload);
/* packet.c */
void set_default_sendable_packets(char *data);
void set_default_receivable_packets(char *data);
void packet_set_available(char *str, int packet_type);
void packet_set_unavailable(char *str, int packet_type);
int packet_is_sendable(int packet_type, char *packet_list);
const char *packet_type_to_string(int packet_type);
int packet_send(struct user *puser, int packet_type, ...);
void packet_broadcast(struct map *pmap, int mode, struct user *puser_exclude, int packet_type, ...);
/* sha1.c */
void sha1(char *digest, char *message, int length);
void sha1_to_str(char *out, char *sha1);
/* socket.c */
void socket_initialize(void);
void socket_set_nonblocking(int sock);
int socket_bind(char *ip, int port);
int socket_accept(char *ip, int length_ip, int parent_socket);
int socket_connect(char *address_in, int port, void *the_sockaddr);
int socket_recv_all(int sock, void *vp, unsigned int size, int timeout);
int socket_send_all(int sock, void *vp, unsigned int size, int timeout);
char *socket_inet_ntop(int ignore, unsigned char *addr, char *out, int length);
int socket_ip_local_get(int sock, char *buffer, int bufflen);
void get_interface_thing(void);
int socket_listener_bind(void);
void socket_listener_unbind(void);
/* log.c */
void log_swap(void);
void log_printf(struct user *puser, int type, char *str, ...);
/* user.c */
int user_authenticate(struct user *puser, struct packet_authenticate_data *auth, int size);
int user_login(struct user *puser, struct map *pmap, int *reason);
void user_mode_set(struct user *puser, int mode);
void user_disconnect(struct user *puser, unsigned char reason, unsigned char delay, char *str);
void user_announce_player(struct user *puser, char *message);
void user_message(struct user *puser, int type, char *str, ...);
void color_strip(char *str);
void mme_to_ascii(char *str);
void user_message_broadcast(struct user *puser, int type, char *str, ...);
void user_send_player_updates(int force);
void user_show_message_file(struct user *puser, char *file);
void user_show_message_file_dialog(struct user *puser, char *file);
void user_set_write_event(struct user *puser, void *location);
unsigned int user_meters_to_blocks(double d, double scale);
int user_send_player_abilities(struct user *puser, int init);
int user_send_map(struct user *puser, int init);
int user_send_block_data(struct user *puser, int init);
int user_send_complete(struct user *puser, int init);
struct user *user_connected_find_by_name(char *name);
struct user *user_attached_find_by_name(char *name);
struct user *user_connected_find_by_id(int id);
void user_chat_private(struct user *puser, char *message);
void str_colorize(char *str);
void user_spawn(struct user *puser, struct float_xyzuv spawn);
void add_to_list(char *name, char *filename);
int remove_from_list(char *name, char *filename);
int in_list(char *name, char *filename);
void user_deallocate(struct user *puser);
void user_connection_setup(void);
int user_record_load(struct user *puser, int id);
int user_record_save(struct user *puser, int id);
void user_kick(struct user *puser, int uid, char *reason);
void user_ipban(struct user *puser, int uid, char *reason);
void user_ban(struct user *puser, int uid, char *reason);
void user_rank_change(struct user *puser, int uid, int rank_id);
int user_name_by_id(struct map *pmap, char *name, int id);
int user_id_by_name(struct map *pmap, char *name, int *id);
int user_id_by_name_partial(struct map *pmap, char *_name, int *id);
int user_ip_is_banned(struct map *pmap, char *ip_address);
int user_is_ignored(struct user *ignorer, int annoyance_uid);
void user_ignore_add(struct user *ignorer, int annoyance_uid);
void user_ignore_remove(struct user *ignorer, int annoyance_uid);
void user_map_switch(struct user *puser, char *name);
void user_connection_history_initialize(void);
void user_connection_history_update(char *name);
struct user *user_online_find_by_id(int id);
char *user_name(struct user *puser, int no_nicknames);
void user_message_chat(struct user *puser, char *message);
int user_test_ignore(struct user *source_user, struct user *destination_user);
void user_afk_toggle(struct user *puser, char *message);
void user_afk_set(struct user *puser, char *message);
void user_afk_clear(struct user *puser, char *message);
void user_iptable_update(struct user *puser);
int user_ip_lookup(struct user *puser, char **out);
void user_damage(struct user *shooter, struct user *victim, int damage);
void user_dead_test(struct user *puser);
void user_mail_display(struct user *puser);
void user_send_crap(struct user *puser);
/* announce.c */
void announce_server(int force);
/* map.c */
int map_check_bounds(struct map *pmap, int x, int y, int z);
unsigned char *map_get_block_pointer(struct map *pmap, int x, int y, int z);
int map_modify(struct map *pmap, struct short_xyz c, int t);
int map_modify_fill(struct user *puser, struct short_xyz start, struct short_xyz finish, int t);
int map_get(struct map *pmap, struct short_xyz c);
int map_load_file(struct map *pmap, char *file_name);
int map_generate(struct map *pmap, int air, int dirt, int grass);
void map_initialize(void);
void map_compress_send_thread(struct user *puser);
int map_compress_send(struct user *puser, int init);
void map_compress_deallocate(struct user *puser);
int map_compress_send_internal(struct user *puser, int init);
int client_modify_test(struct user *puser, const struct map_modify *pmodify, char *err);
int modify_client_map(struct user *puser, struct map_modify *pmodify, int damage_flag);
void map_disk_sync(int dump);
int map_area_save(struct map *pmap);
int map_save(struct map *pmap);
void file_replace(char *perminant, char *temporary);
int map_fix_fill_coordinates(struct user *puser, struct map_fill *pmodify);
int map_client_fill(struct user *puser, struct map_fill *pmodify, int size);
int zlib_deflate(char *in, int in_size, char *out, int *out_size);
int zlib_inflate(char *in, int in_size, char *out, int *out_size);
void map_region_copy(struct map *pmap, struct int_xyz src_dimension, struct int_xyz dest_dimension, struct int_xyz src_start, struct int_xyz src_end, struct int_xyz dest_offset, unsigned char *src_buffer, unsigned char *dest_buffer);
void map_draw_circle(struct user *puser, short cx, short cy, short cz, int radius, unsigned char block);
void map_draw_sphere(struct user *puser, short x, short y, short z, short radius, short block);
void map_close_all(void);
struct map *map_struct_find_by_filename(char *str);
struct map *map_struct_find_by_name(char *str);
struct map *map_struct_find_empty(void);
void map_unload(struct map *pmap);
void map_update_compressed_data_with_coordinates(struct user *puser, unsigned char *data, int size, int16_t lx, int16_t ly, int16_t lz, int16_t ux, int16_t uy, int16_t uz);
void map_update_compressed_data(struct user *puser, unsigned char *data, int size);
int map_compressed_region_broadcast(struct user *puser, struct short_xyz start, struct short_xyz finish);
int map_compressed_region_send(struct user *puser, struct short_xyz start, struct short_xyz finish);
void map_region_copy_data(struct short_xyz src_dimension, struct short_xyz dest_dimension, struct short_xyz src_start, struct short_xyz src_end, struct short_xyz dest_offset, unsigned char *src_buffer, unsigned char *dest_buffer);
void map_region_copy_data_with_undo(struct user *puser, struct short_xyz src_dimension, struct short_xyz dest_dimension, struct short_xyz src_start, struct short_xyz src_end, struct short_xyz dest_offset, unsigned char *src_buffer, unsigned char *dest_buffer);
struct map *map_struct_find_appropriate(struct user *puser, struct map *ignoremap);
int map_count_active(void);
void map_undo_log(struct user *puser, short x, short y, short z, unsigned char block);
void map_undo_undo(struct user *puser, int seconds);
void map_block_change(struct map *pmap, int x, int y, int z, unsigned char block, int who);
int map_region_save(struct map *pmap, char *filename, int fx, int fy, int fz, int tx, int ty, int tz);
int map_region_load(struct map *pmap, char *filename, int fx, int fy, int fz, int tx, int ty, int tz);
struct map *map_create(char *file, int x, int y, int z, int sealevel);
void map_explosion(struct user *puser, int x, int y, int z);
void map_set_modified(struct map *pmap, int x, int y);
int map_region_send(struct user *puser, struct short_xyz start, struct short_xyz finish, int broadcast);
void map_flow_kill(void);
void map_flow_proc(void);
struct flow_properties *map_flow_find_empty(void);
void map_flow_start(struct user *puser, int x, int y, int z, int block, int depth, int who);
/* config.c */
int config_logic_symbol(char *str);
int config_salt_save(void);
int config_initialize(void);
int config_server_online(int state);
void config_save(void);
/* texture.c */
struct texture *texture_add_with_defaults(struct palette *pp, char *filename);
int true_false(char *str);
int sha1_file(char *filename, char *sha1_out);
int text_sort(char *str1, char *str2);
void texture_sort_range(struct palette *pp, int first, int last);
int texture_block_by_description(struct palette *pp, char *name);
void texture_name_data_parse(struct texture *ptexture);
void block_initialize(struct palette *pp, char *filename);
struct texture *texture_find_by_filename(struct palette *pp, char *filename);
struct texture *texture_find_empty(struct palette *pp);
struct texture *texture_find_by_sha1(struct palette *pp, char *sha1);
void add_block_group(struct palette *pp, char *str, int block_id);
int texture_send_block_groups(struct user *puser);
int texture_send_texture_info(struct user *puser);
int texture_send_blocks(struct user *puser);
int texture_palette_count_active(void);
struct palette *texture_find_palette_struct_by_name(char *str);
struct palette *texture_find_palette_empty(void);
int skin_texture_find_id_by_name(struct palette *pp, char *name);
int skin_struct_find_id_by_name(struct palette *pp, char *name);
int texture_active_palette_count(void);
struct palette *texture_palette_load(char *name);
void texture_skin_change_broadcast(struct map *pmap, struct user *ignore_user, int model_id, char *skin_name);
void texture_skin_change(struct user *puser, int model_id, char *skin_name);
void texture_send_skybox_info(struct user *puser);
/* event.c */
void event_proc(struct user *puser);
void event_authentication_complete(struct user *puser);
void event_map_loading_complete(struct user *puser);
void event_user_disconnect(struct user *puser);
void event_player_position_changed(struct user *puser, struct float_xyzuv new_position);
void event_nick_change(struct user *puser);
void event_user_is_afk(struct user *puser, char *message);
void event_user_not_afk(struct user *puser, char *message);
/* menu_stack.c */
int menu_set_check(int i);
struct menu_stack_item *menu_get_current_stack_item(struct user *puser);
void menu_stack_clear(struct user *puser);
void menu_stack_set(struct user *puser, void *vp);
void menu_stack_set_pointer_only(struct user *puser, void *vp);
void menu_stack_push(struct user *puser, void *vp);
void menu_stack_pop(struct user *puser);
void *menu_stack_push_init(struct user *puser, void *vfp, void *mem_addr, int alloc_size);
void *menu_get_current_stack_item_memory(struct user *puser);
void menu_proc(struct user *puser, int id);
int menu_command_parse(struct user *puser, int *number, int *name, int *value, int *flags, unsigned char *text);
void menu_kill(struct user *puser);
/* map_journal.c */
int map_journal_get(struct map *pmap, short x, short y, short z, struct map_journal *data);
void map_journal_update(struct map *pmap, int id, int x, int y, int z, int new_block, int old_block);
void map_journal_update_fill(struct map *pmap, int id, struct short_xyz start, struct short_xyz finish, int new_block);
void map_journal_undo(struct user *puser, int id, time_t to_stamp);
void map_journal_open(struct map *pmap);
void map_journal_close(struct map *pmap);
/* rank.c */
void rank_initialize(void);
void rank_use_internal_defaults(void);
void rank_command_allowed_add(struct rank *prank, char *str);
void rank_command_allowed_remove(struct rank *prank, char *str);
void rank_menu_allowed_add(struct rank *prank, char *str);
void rank_menu_allowed_remove(struct rank *prank, char *str);
int rank_command_allowed(struct rank *prank, char *cmd);
int rank_menu_allowed(struct rank *prank, char *cmd);
struct rank *rank_struct_by_lowest(void);
int rank_id_by_highest(void);
struct rank *rank_struct_by_highest(void);
int rank_id_find_empty(void);
int rank_id_by_name(char *str);
struct rank *rank_find_struct_by_name(char *str);
int rank_compare_by_name(char *str1, char *str2);
int rank_compare_by_name_ge(char *str1, char *str2);
int rank_struct_promote_limits(struct rank *prank, int *max);
int rank_count_active(void);
/* command.c */
int command_tp(struct user *puser, char *command, char *parameters);
int command_fly(struct user *puser, char *command, char *parameters);
int command_box(struct user *puser, char *command, char *parameters);
int command_color(struct user *puser, char *command, char *parameters);
int command_me(struct user *puser, char *command, char *parameters);
int command_who(struct user *puser, char *command, char *parameters);
int command_all(struct user *puser, char *command, char *parameters);
int command_ban(struct user *puser, char *command, char *parameters);
int command_ipban(struct user *puser, char *command, char *parameters);
int command_kick(struct user *puser, char *command, char *parameters);
int command_shutdown(struct user *puser, char *command, char *parameters);
int command_rank(struct user *puser, char *command, char *parameters);
int command_rank_show(struct user *puser, char *command, char *parameters);
int command_unban(struct user *puser, char *command, char *parameters);
int command_server(struct user *puser, char *command, char *parameters);
int command_lag(struct user *puser, char *command, char *parameters);
int command_sphere(struct user *puser, char *command, char *parameters);
int command_circle(struct user *puser, char *command, char *parameters);
int command_join(struct user *puser, char *command, char *parameters);
int command_map_unload(struct user *puser, char *command, char *str);
int command_map_load(struct user *puser, char *command, char *str);
int command_map_load_area(struct user *puser, char *command, char *str);
int command_reload_ranks(struct user *puser, char *command, char *parameters);
int command_list_maps(struct user *puser, char *command, char *parameters);
int command_reload(struct user *puser, char *command, char *parameters);
int command_server_shutdown(struct user *puser, char *type, char *str);
int command_palette_load(struct user *puser, char *command, char *parameters);
int command_map_create(struct user *puser, char *command, char *parameters);
void list_variables(struct user *puser);
char *variable_get_value(struct user *puser, char *in, char *out, int out_length);
int command_set(struct user *puser, char *ignored, char *parameters);
int command_say(struct user *puser, char *command, char *parameters);
int command_map_sync(struct user *puser, char *command, char *parameters);
int command_zombie(struct user *puser, char *command, char *parameters);
int command_afk(struct user *puser, char *command, char *parameters);
int command_npc_create_type(struct user *puser, char *command, char *parameters);
int command_npc_spawn_type(struct user *puser, char *command, char *parameters);
int command_rank_create(struct user *puser, char *command, char *parameters);
int command_replace_block(struct user *puser, char *command, char *parameters);
int command_map_undo(struct user *puser, char *command, char *parameters);
int command_map_region_save(struct user *puser, char *command, char *parameters);
int command_map_region_load(struct user *puser, char *command, char *parameters);
int command_lua_exterminate(struct user *puser, char *command, char *parameters);
int command_quit(struct user *puser, char *command, char *parameters);
int command_list_connections(struct user *puser, char *command, char *parameters);
int command_config_save(struct user *puser, char *command, char *parameters);
int command_list_ranks(struct user *puser, char *command, char *parameters);
int command_list_palettes(struct user *puser, char *command, char *parameters);
int command_lua_hookfile_list(struct user *puser, char *command, char *parameters);
int command_lua_load_hookfile(struct user *puser, char *command, char *parameters);
int command_lua_unload_hookfile(struct user *puser, char *command, char *parameters);
int command_flow_kill(struct user *puser, char *command, char *parameters);
int command_flow(struct user *puser, char *command, char *parameters);
int command_npc_exterminate(struct user *puser, char *command, char *parameters);
int command_map_backup(struct user *puser, char *command, char *str);
int command_goto(struct user *puser, char *command, char *parameters);
int command_summon(struct user *puser, char *command, char *parameters);
int command_config_reload(struct user *puser, char *command, char *parameters);
int command_game_mode(struct user *puser, char *command, char *parameters);
int command_up(struct user *puser, char *command, char *parameters);
int command_spam(struct user *puser, char *command, char *parameters);
int command_echo(struct user *puser, char *command, char *parameters);
int command_proc(struct user *puser, char *cmd);
int command_list_name_get(int *idx, char *name);
int command_help_lookup(struct user *puser, char *command);
void expand_data_tags(struct user *puser, char *str, int length);
/* thread.c */
void thread_lock_init(struct structure_rwlock *rwlock);
void thread_lock_read(struct structure_rwlock *rwlock);
void thread_unlock_read(struct structure_rwlock *rwlock);
void thread_lock_write(struct structure_rwlock *rwlock);
void thread_unlock_write(struct structure_rwlock *rwlock);
void thread_priority_background(void);
void thread_create(void *function, void *parameter);
void thread_exit(void);
/* console.c */
void console_initialize(void);
int console_exec_file(char *file);
void console_proc(void);
/* menu_connected_players.c */
int menu_connected_players(struct user *puser, int message_id);
int menu_rank_choose(struct user *puser, int message_id, int max_rank, int s_menu_name, int s_menu_value);
int menu_color_choose(struct user *puser, int message_id, int name, int value);
/* menu_dialog.c */
int wrap_text(char *text, int column);
int text_newline_array(char *in, char *argv[], int max);
int menu_dialog(struct user *puser, int message_id, char *title, char *text, char *button);
int menu_area_dialog(struct user *puser, int message_id, int area_number);
int menu_dialog_yesno(struct user *puser, int message_id, char *title, char *text, int response);
int menu_killed_dialog(struct user *puser, int message_id);
/* menu_edit_box.c */
int menu_edit_box(struct user *puser, int message_id, char *info, char *text, int length, int name, int value);
/* menu_journal_dialog.c */
int menu_journal_dialog(struct user *puser, int message_id);
/* area.c */
void area_initialize(struct map *pmap);
int area_find_empty(struct map *pmap);
void area_file_path_make(struct map *pmap, char *output, int id, char *name);
int area_create_file(struct user *puser, char *name);
int area_create_raw(struct map *pmap, unsigned char **return_data);
void area_release(struct user *puser);
void area_start(struct map *pmap, int num, short *x, short *y);
void area_map_merge(struct map *pmap, char *data, int num);
int area_load(struct user *puser, int num, char *area_name);
void area_list_save(struct map *pmap);
int area_save(struct map *pmap, int num);
int area_save_to(struct map *pmap, int num, struct user *puser);
int area_is_reserved(struct map *pmap, int num);
void area_player_locate(struct user *puser, int num);
void area_load_player(struct user *puser);
int area_for_player(struct user *puser);
int area_in(struct map *pmap, short position_x, short position_y);
int area_modify_test(struct user *puser, short x, short y, short z, char *err);
int area_invite_player(struct user *puser, int num);
int area_uninvite_player(struct user *puser, int num);
void area_uninvite_player_all(struct user *puser);
int area_is_invited(struct map *pmap, char *name, int num);
void area_sync(struct map *pmap);
void area_swap(struct user *puser, char *name);
void area_delete(struct user *puser, char *name);
void area_name_loaded(struct user *puser, char *name);
void area_record_clear(struct map *pmap, int num);
int area_reload(struct map *pmap, int num);
int area_blank(struct user *puser, int num);
void area_region_copy(struct int_xyz src_dimension, struct int_xyz dest_dimension, struct int_xyz src_start, struct int_xyz src_end, struct int_xyz dest_offset, char *src_buffer, char *dest_buffer);
int area_save_file(char *file_name, char *data, struct map *pmap);
int area_load_file(char *file_name, char **data_out, struct map *pmap);
int area_map_transform(char **data_in, short sx, short sy, short sz, short dx, short dy, short dz, short sealevel, unsigned char dirt_block, unsigned char grass_block);
int area_find_newest_area(struct map *pmap, int uid, char *out);
/* menu_area.c */
int area_user_count(struct user *puser);
int menu_area_manager(struct user *puser, int message_id);
int menu_create_area(struct user *puser, int message_id, void *parent);
int menu_rename_area(struct user *puser, int message_id, void *parent);
/* menu_skin.c */
int menu_skin_manager(struct user *puser, int message_id);
/* btr.c */
int btr_file_read_serial(FILE *fn1, unsigned char *id, char *name, char **data_ptr, size_t *data_length_read);
int btr_file_write_serial(FILE *fn1, unsigned char id, char *name, char *data, size_t data_length);
/* lua.c */
int lua_hookfile_load(char *file);
int lua_hookfile_remove(char *file);
void lua_hookfile_list(struct user *puser);
void lua_exterminate(void);
struct lua_hookfile *lua_hookfile_new(char *file);
void lua_initialize(void);
int lua_parameter_expand(lua_State *L, char *func_name, char *parameters, ...);
struct lua_hookfile *lua_hookfile_struct_find(char *name);
int lua_hook_call(char *hook_name, struct user *puser, ...);
int mme_server__newindex(lua_State *L);
int mme_server__index(lua_State *L);
int mme_map__newindex(lua_State *L);
int mme_map__index(lua_State *L);
void pppp(lua_State *L);
void lua_exec_init(lua_State *L);
int lua_exec(struct user *puser, char *file, char *args);
int lua_exec_mem(struct user *puser, char *memory, char *args);
/* process.c */
void process_server_periodic(void);
int process_user_connection_health(struct user *puser);
int process_user_connection_read(struct user *puser, int new_data);
int process_user_connection_write(struct user *puser);
int process_packet(struct user *puser, unsigned short packet_type, char *data, unsigned short size);
void process_send_raw_data(struct user *puser, char *packet, size_t size);
/* npc.c */
void npc_verify_position(struct npc *pnpc);
int chance(int percent);
struct npc *npc_find_empty(void);
void npc_initialize(void);
int npc_find_type_empty(void);
int npc_find_type_by_name(char *name);
struct npc_type *npc_find_type_struct_by_name(char *name);
void npc_proc(void);
int f_npc_random_movement(struct npc *pnpc, int init);
int f_npc_initialize(struct npc *pnpc, int init);
int f_npc_find_food(struct npc *pnpc, int init);
int f_npc_find_water(struct npc *pnpc, int init);
int f_npc_find_comfort(struct npc *pnpc, int init);
int f_npc_find_social(struct npc *pnpc, int init);
int surface_height(struct map *pmap, int x, int y, int z);
void bit_set(int the_bit, char *str);
int bit_is_set(int the_bit, char *packet_list);
int npc_can_see(struct npc *pnpc, int type, void **data, int data_elements);
int distance_from_xy(int fx, int fy, int tx, int ty);
int npc_move(struct npc *pnpc, int new_x, int new_y, int new_z, int test);
int npc_move2(struct npc *pnpc, int from_x, int from_y, int from_z, int new_x, int new_y, int new_z);
int iabs(int p);
int in_width_xyz(struct map *pmap, int sx, int sy, int sz, int vx, int vy, int vz);
int npc_move_blocked(struct npc *pnpc, int sx, int sy, int sz);
void npc_announce(struct user *puser);
struct user *npc_target_user_closest(struct npc *pnpc);
void npc_attack_user_closest(struct npc *pnpc);
void npc_damage_me(struct npc *pnpc);
int npc_add(struct map *pmap, char *name, int x, int y, int z);
void npc_remove(int id);
int in_model(int x, int y, int z, float mx, float my, float mz);
/* menu_management.c */
int menu_management_timeout(struct user *puser, int init);
int menu_management_entry(struct user *puser, int message_id);
int menu_management(struct user *puser, int message_id);
/* request.c */
void request_initialize(void);
struct file_request *file_request_struct_find_empty(void);
void request_file_add(char *file);
void request_queue_by_sha1(struct user *puser, char *sha1);
void request_send_proc(struct user *puser);
/* menu_area_list.c */
int menu_area_list(struct user *puser, int message_id);
/* menu_server_config.c */
int menu_server_config(struct user *puser, int message_id, int id);
/* backtrace.c */
void backtrace_sigsegv_handler(int number);
